package main

import (
	"flag"
	"fmt"
	"gitlab.schukai.com/oss/libraries/go/network/traceroute"
)

const (
	flagValue = ""
	flagUsage = "hostname or ip address"
)

func main() {

	var host string

	flag.StringVar(&host, "h", flagValue, flagUsage+" (shorthand)")
	flag.StringVar(&host, "host", flagValue, flagUsage)
	flag.Parse()

	if host == "" {
		fmt.Println("missing host")
		flag.Usage()
		return
	}

	session, err := traceroute.NewSession(host)
	if err != nil {
		flag.Usage()
		return
	}

	session.CallBack = func(result traceroute.Result) {
		if result.Err!=nil {
			fmt.Printf("%v\t%s\t\t\t\t%v\t\t(%s)\n", result.Hop, result.Station, result.Latency, result.Err.Error())
			return
		}
		
		fmt.Printf("%v\t%s\t\t\t%v\n", result.Hop, result.Station, result.Latency)
	}

	_, err=session.TraceRoute()
	if err!=nil {
		fmt.Println(err.Error())
	}

}
