package traceroute

import (
	"fmt"
	"strings"
	"testing"
)

func TestTraceroute(t *testing.T) {

	testCases := []struct {
		destination        string
		shouldSessionError bool
	}{
		{
			"ipv6.google.com",
			false,
		},		{
			"www.schukai.com",
			false,
		},
	}

	for _, tc := range testCases {

		t.Run(fmt.Sprintf(""), func(t *testing.T) {

			session, err := NewSession(tc.destination)
			if err != nil {
				if !strings.Contains(err.Error(), "no suitable interface was found") {
					t.Errorf("%s shout not error %s", tc.destination, err.Error())	
				}
				return
			}

			_,err = session.TraceRoute()
			if err != nil {
				t.Errorf("%s shout not error %s", tc.destination, err.Error())
			}

		})

	}

}

func benchmarkTraceroute(address string, b *testing.B) {
	for n := 0; n < b.N; n++ {
		resolve(address)
	}
}

func BenchmarkTraceroute1(b *testing.B) { benchmarkTraceroute("www.google.com", b) }
